const text_screen = $0400

Start:
	ldx #text_screen    ; 
	stx cursor          ; cursor = text_screen
	ldd #$FDCB          ; 
	lbsr PrintHex       ; PrintHex(d = FDCB)
	ldd #space		    ; 
	lbsr PrintStr       ; PrintStr(d = space)
	ldd #$1234          ; 
	lbsr PrintHex       ; PrintHex(d = 1234)
	rts

PrintStr:
	; the string is in the accumulator D
	pshs y              ; save y
	ldx cursor          ; x = cursor
	
	tfr d,y             ; y = d
print_str_loop:
	lda ,y+             ; a = mem[y++]
	cmpa #0             ; if (a == 0)
	beq print_str_done  ;   goto print_str_done
	sta ,x+             ; mem[x++] = a
	bra print_str_loop  ; goto print_str_loop
print_str_done:
	stx cursor          ; cursor = x
	puls y              ; restore y
	rts

PrintHex:
	; the number is in the accumulator D
	pshs y              ; save y
	ldx cursor          ; x = cursor

	tfr d,y             ; y = d
	lsra                
	lsra                 
	lsra
	lsra                ; a = y >> 8 >> 4
	bsr DigitOptimized  
	tfr y,d
	anda #$0F           ; a = y >> 8 & 0x0F
	bsr DigitOptimized  
	lsrb
	lsrb
	lsrb
	lsrb
	tfr b,a             ; a = y >> 4 & 0x0F
	bsr DigitOptimized
	tfr y,d
	andb #$0F
	tfr b,a             ; a = y & 0x0F
	bsr DigitOptimized  

	stx cursor
	puls y
	rts

DigitOptimized:
    ; the digit is in the accumulator A
	; make sure: 
	; - ldx cursor before
	; - sdx cursor after
	cmpa #$0A           ; if (a >= 10)
	blo if_digit	    ;   goto if-digit
	suba #$9	    ; 
	bra if_merge	    ; goto if-merge
if_digit:
    	adda #'0'		; a += '0'
if_merge:
    	sta ,x+			; mem[x + 1] = d
    	rts

cursor:
    	.word 0			; cursor = 0

space:
	.byte ' ', 0