const text_screen = $0400

Start:
    ldx #text_screen    ; x = text_screen
    stx cursor          ; cursor = x
    ldd #25             ; d = 25
    pshs d              ; mem[--s] = d
    lbsr Fibonacci      ; call Fibonacci
    puls d              ; d = mem[s++]
    rts

Fibonacci:              ; fib requires a parameter in a
    pshs u              ; mem[--s] = u
    leau ,s             ; u = s

    ldd #0              ; d = 0
    pshs d              ; mem[--s] = d          def a = 0
    ldd #1              ; d = 1
    pshs d              ; mem[--s] = d          def b = 1
fib_loop:
    ldd $04, u          ; d = mem[u + 4]
    cmpd #0             ; if d = 0              if n = 0
    beq fib_done        ; return 0
    subd #1             ; d = d - 1 
    std $04,u           ; mem[u + 4] = d        n = n - 1

    ldd $02,s           ; d = mem[s + 2]
    lbsr PrintHex       ; call PrintHex

    ldd $04,u           ; d = mem[u + 4]
    cmpd #0             ; if d = 0              if n = 0
    beq skip_comma      ; goto skip_comma
    ldd #comma          ; d = comma
    lbsr PrintStr       ; call PrintStr
skip_comma:
    ldd ,s              ; d = mem[s]
    addd $02,s          ; d = mem[s + 2]        a = mem[s] + mem[s + 2]
    ldx ,s              ; x = mem[s]            x = mem[s]
    std ,s              ; mem[s] = d            mem[s] = a
    stx $02,s           ; mem[s + 2] = x        mem[s + 2] = x

    bra fib_loop        ; goto fib_loop
fib_done:
    leas ,u             ; s = u
    puls u              ; u = mem[s++]
    rts                 ; return

PrintStr:
    ; the string is in the accumulator D
    pshs y              ; save y
    ldx cursor          ; x = cursor
    
    tfr d,y             ; y = d
print_str_loop:
    lda ,y+             ; a = mem[y++]
    cmpa #0             ; if (a == 0)
    beq print_str_done  ;   goto print_str_done
    sta ,x+             ; mem[x++] = a
    bra print_str_loop  ; goto print_str_loop
print_str_done:
    stx cursor          ; cursor = x
    puls y              ; restore y
    rts

PrintHex:
    ; the number is in the accumulator D
    pshs y              ; save y
    ldx cursor          ; x = cursor

    tfr d,y             ; y = d
    lsra
    lsra
    lsra
    lsra                ; a = y >> 8 >> 4
    bsr DigitOptimized
    tfr y,d
    anda #$0F           ; a = y >> 8 & 0x0F
    bsr DigitOptimized
    lsrb
    lsrb
    lsrb
    lsrb
    tfr b,a             ; a = y >> 4 & 0x0F
    bsr DigitOptimized
    tfr y,d
    andb #$0F
    tfr b,a             ; a = y & 0x0F
    bsr DigitOptimized

    stx cursor
    puls y
    rts

DigitOptimized:
    ; the digit is in the accumulator A
    ; make sure: 
    ; - ldx cursor before
    ; - sdx cursor after
    cmpa #$0A           ; if (a >= 10)
    blo if_digit		;   goto if-digit
    suba #$9			; 
    bra if_merge		; goto if-merge
if_digit:
    adda #'0'           ; a += '0'
if_merge:
    sta ,x+             ; mem[x + 1] = d
    rts

cursor:
    .word 0             ; cursor = 0

space:
    .byte ' ', 0
comma:
    .byte ',', 0